\documentclass{beamer}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{graphicx}
\usepackage{pgfplots} 
\usepackage{multicol}
\usepackage{amsmath, amsthm, amssymb, amsfonts}
\usepackage{dsfont}
\usepackage{subfig}


\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage[style=british]{csquotes}
\def\signed #1{{\leavevmode\unskip\nobreak\hfil\penalty50\hskip1em
		\hbox{}\nobreak\hfill #1%
		\parfillskip=0pt \finalhyphendemerits=0 \endgraf}}

\newsavebox\mybox
\newenvironment{aquote}[1] {\savebox\mybox{#1}\begin{quote}\openautoquote\hspace*{-.7ex}}
	{\unskip\closeautoquote\vspace*{1mm}\signed{\usebox\mybox}\end{quote}}
\DeclareMathOperator*{\argmin}{argmin}
\DeclareMathOperator*{\argmax}{argmax}
\usetheme{Madrid}
\usecolortheme{default}

%\usetheme[department=info,smalllogo=true]{ENSRennes}
%\usetheme[department=info]{ENSRennes}

\newcommand\alertb[2]{\begin{alertblock}{#1}#2\end{alertblock}}

\newcommand\exampleb[2]{\begin{exampleblock}{#1}#2\end{exampleblock}}

\newcommand\newb[2]{\begin{block}{#1}#2\end{block}}

\newcommand {\framedgraphic}[2] {
	\begin{frame}{#1}
		\begin{center}
			\includegraphics[width=2.\textwidth,height=1.3\textheight,keepaspectratio]{#2}
		\end{center}
	\end{frame}
}


\title[Hippocampus modeling]{Investigation of the successor representation for neuro-computational models of the hippocampus}
\author[Romain Ferrand]{Romain Ferrand\\[10mm]{\small Supervisors: Julien Vitay\inst{1}}}
\institute[ENS de Rennes]{
	\inst{1}%
	Faculty of Computer Science\\
	Chemnitz University of Technology
}


\date{August 29, 2019}

\AtBeginSection[]
{
	\begin{frame}
		\frametitle{Table of Contents}
		\tableofcontents[currentsection]
	\end{frame}
}
%------------------------------------------------------------


\begin{document}
	
	%The next statement creates the title page.
	\frame{\titlepage}
	
	
	%---------------------------------------------------------
	%This block of code is for the table of contents after
	%the title page
	\begin{frame}
		\frametitle{Table of Contents}
		\tableofcontents
	\end{frame}

\section{The hippocampus}
\subsection{Cognitive context}
\begin{frame}{Hippocampus anatomy}
	\begin{figure}
		\centering
		\subfloat{\includegraphics[width=0.8\textwidth]{img/1511_The_Limbic_Lobe.jpg} \label{fig:sub1}}
		\subfloat{\includegraphics[width=0.2\textwidth]{img/Hippocampus_and_seahorse_cropped.jpg} \label{fig:sub2}}
	\end{figure}
\end{frame}
\begin{frame}{Hippocampus: it's all about memory}
	\begin{itemize}
		\item consolidation of declaratif memory (short to long term)
		\item spatial memory
		\item episodic memory (information in sequences like video, music, words)
		\\
		\pause
		\newb{Objective}{
		modelize spatial and episodic memory encoded by the same neural substract: the \emph{place-cell}}
\end{itemize}
\end{frame}
\subsection{The cognitive map theory}
\begin{frame}{Place-cells and the cognitive map theory (1978)}
		\begin{figure}
			\centering
\subfloat{\includegraphics[width=0.8\linewidth]{img/maze_maps.pdf} \label{fig:cog_maps}}

\subfloat{\includegraphics[width=0.5\linewidth]{img/place-cell-animation-1-0.png} \label{fig:anim_rat}}
	\end{figure}
\end{frame}


\subsection{The predictive map theory}
\begin{frame}{The predictive map theory}
	\newb{Limits of cognitive map}{
	\begin{itemize}
		\item Place cells activity is behaviorally dependant
		\item Place cells are used for replay during rest phase
	\end{itemize}}
		\begin{figure}
		\centering
		\includegraphics[width=\linewidth]{img/replay_hippocampus.jpg}
		%\caption{Two line long caption}
		\label{fig:replay}
	\end{figure}
\end{frame}

\section{Neurobiologically compatible Reinforcement learning}
\subsection{General definition of RL}
\begin{frame}{General definition of RL}
	Reinforcement learning:
	\begin{aquote}{Richard Sutton}
		Reinforcement learning is a way to translate situations, perceptions to actions 
	\end{aquote}
		\begin{figure}
		\centering
		\includegraphics[width=0.7\linewidth]{img/MDP.pdf}
		%\caption{Two line long caption}
		\label{fig:replay}
	\end{figure}
\end{frame}
\begin{frame}{Optimal policy of action and value function}
	Agent's objective: find the action policy which maximizes its rewards from the time $t$ until the end of its lifespan.
	\begin{align}
	\pi^{*} = \argmax_{\pi} \mathbb{E}_{\pi}[\sum\limits_{k=0}^{\infty} \gamma^k R_{t+k+1}] \nonumber \\
	G_{t} = \sum\limits_{k=0}^{\infty} \gamma^k R_{t+k+1} \nonumber
	\end{align}
	State value function satisfy bellman equation
	\begin{align}
		v^{\pi}(s) &= \mathbb{E}_{\pi}[G_t | S_t = s] \nonumber \\
		&= \mathbb{E}_{\pi}[R_t + \gamma G_{t+1}| S_{t+1} = s] \nonumber \\
		&= \sum\limits_{a \in \mathcal{A}(s)} \pi(a|s) \sum\limits_{s' \in \mathcal{S}} P(s' | s, a)[R(s,a) + \gamma\mathbb{E}_{\pi}[G_{t+1}| S_{t+1} = s']] \nonumber
	\end{align}
\end{frame}
\subsection{Actor-critic learning}
\begin{frame}{Actor-critic}
	\begin{figure}
		\centering
		\includegraphics[width=0.65\linewidth]{img/sutton_AC.png}
		%\caption{Two line long caption}
		\label{fig:AC}
	\end{figure}
\end{frame}
\begin{frame}{Actor-critic: definitions}
	\newb{Actor}{
		\begin{itemize}
			\item State to action matrix: $A \in R^{n \times d}$
			\item State as one-hot encoded feature vector
		\end{itemize}
	}
	\newb{Critic}{
		\begin{itemize}
			\item Use temporal difference error as signal $\delta = R_{t+1} + \gamma_{td}V(S_{t+1}) - V(S_t)$ 
			\item Use successor representation to rewrite state value-function
		\end{itemize}
	}
\end{frame}
\subsection{The successor representation}
\begin{frame}{The successor representation}
	\newb{SR: predictive future relation between states}{
		\begin{itemize}
			\item SR rewrite value function in terms of discounted probability between states
			\item Account for predictive encoding 
		\end{itemize}
	}

\begin{align}
	v^{\pi}(s) = \sum\limits_{s' \in \mathcal{S}} M^{\pi}(s,s')\sum\limits_{a \in \mathcal{A}(s)}\pi(a|s')R(s',a) \nonumber \\
	  M^{\pi}(s_i, s_j) = \mathbb{E}_{\pi}[\sum\limits_{k=0}^{\infty} \gamma^{k}\mathbb{I}(S_{t+k} = s_j)| S_t = s_i] \nonumber
\end{align}
	\begin{itemize}
	\item  $M^{\pi}(s_i, s_j)$ grow by the number of \emph{forward} path possible between $s_i$ and $s_j$ states
	\item importance of distance relation decrease exponentially by a $\gamma$ factor 
\end{itemize}
\end{frame}
\begin{frame}{SR temporal difference}
	\begin{itemize}
		\item Compute SR matrix by an on-line procedure
	\end{itemize}
	Following the transition $s \overset{a}{\rightarrow} s'$:
	\begin{align*}
		  \delta = \mathbb{I}(i = s) + \gamma M^{\pi}(s',i) - M^{\pi}(s,i) \nonumber \\
		M^{\pi}(s, i) \leftarrow M^{\pi}(s, i) + \alpha_{sr}\delta, \quad \forall i \in \mathcal{S}
	\end{align*}
\end{frame}



\subsection{Multi-time scale SR}
\begin{frame}{Multi-time scale SR}
	\alertb{SR depend on $\gamma$ forgetting parameter}{
		\begin{itemize}
			\item too low, only short term relation will be know to the agent
			\item too high, long and short relation information will overlap
		\end{itemize}
	}
SR in terms of $\gamma$ is a \alert{laplace transform} \footnotemark
\begin{align}
M^{\pi}(\gamma) = \sum\limits_{t=0}^{\infty} \gamma^{t} {T^{\pi}}^{t} &\approx \int\limits_{0}^{\infty} \gamma^{t} {T^{\pi}}^{t} dt \nonumber \\ &\approx \int\limits_{0}^{\infty} e^{-\sigma t}{T^{\pi}}^{t} dt \nonumber & \sigma &= - \ln(\gamma)
\end{align}
\footnotetext[1]{Momennejad, Ida \& Howard, Marc. (2018). Predicting the future with multi-scale successor representations. 10.1101/449470.}
\end{frame}
\begin{frame}{Multi-time scale SR}
	\begin{itemize}
		\item Inverse Laplace transform $L^{-1}$ is a transition matrix in terms of $t$.
	\end{itemize}
\begin{align}
	T^{t}(s_i, s_j) = \Pr\{S_t = s_j | S_0 = s_i\} \nonumber
\end{align}
	\begin{itemize}
	\item $T^{t}(s_i, s_j)$ is maximal when $t$ is equal to the time/distance between $s_i$ and $s_j$.
	\end{itemize}
\begin{align}
	D(i,j) = \argmax_{t} T^{t}(i,j) \nonumber
\end{align}
\begin{itemize}
	\item $D$ act as a distance matrix between states 
\end{itemize}
\end{frame}
\begin{frame}{Multi-time scale SR}
	\newb{Perspectives}{
	\begin{itemize}
		\item $D$ provide topological information between states
		\item $D$ can be obtain by an on-line scalar signal (coherent with dopaminergic signal) 
\end{itemize}}
	\alertb{Limitations}{
	\begin{itemize}
		\item Proof of concept framework (no RL algorithms available)
		\item No comparison with SR methods 
\end{itemize}}
\end{frame}
\section{Contribution}
\subsection{Learning with distance information}
\begin{frame}{SR-distance state value-function}
	\newb{SR-distance}{
		\begin{align*}
		v^{\pi}(s) &  \approx \sum\limits_{s' \in \mathcal{S}} \frac{1}{Rank(D(s,s'))}w(s')
		\end{align*}
		Following the transition $s \overset{a}{\rightarrow} s'$, we update $w$ and $A$:
		\begin{align*}
		w(i) &\leftarrow w(i) + \alpha_{td} \delta \frac{1}{Rank(D(s,i))} \nonumber \\
		A(a, i) &\leftarrow A(a, i) + \beta_{td} \delta \mathbb{I}(i = s), \quad\forall i \in \mathcal{S}
		\end{align*}
	}
	\alertb{Dense ranking transformation of D}{
		\begin{itemize}
			\item $D$ is unbounded ($D \in [0,+\infty]$)
			\item dense ranking\footnotemark on $i^{\text{th}}$ row of $D$ extract ordinality in terms of the distance between state $s$ and all others states
		\end{itemize}
	}
	\footnotetext[3]{$Rank([0.1, 0.3, 0.2, 0.2]) = [1,3,2,2]$}
\end{frame}
\subsection{Food retrieval modelling}
\begin{frame}{Food retrieval}
	\newb{Objectives}{
		Model how animal cope with:
		\begin{itemize}
			\item environment changes (change in transition function)
			\item behavioural changes (change in reward function)
		\end{itemize}
		Compare SR with SR-distance method
	}
\end{frame}
\begin{frame}{Environment changes: experimental protocol}
\begin{columns}
	\begin{column}{0.5\textwidth}
		\begin{enumerate}
			\item mouse explore maze without cheese and brown barrier 
			\item cheese is added
			\item mouse run $20$ episodes of food retrieval
			\item brown barrier is added 
			\item mouse run $20$ episodes of food retrieval
		\end{enumerate}
	\end{column}
	\begin{column}{0.5\textwidth}  %%<--- here
		\begin{center}
			\includegraphics[width=\textwidth]{img/detour_maze.pdf}
		\end{center}
	\end{column}
\end{columns}
\end{frame}
\begin{frame}{Environment changes: results}
	\begin{figure}
		\includegraphics[width=\textwidth]{img/Detour_tolman_maze.pdf}
		%\caption{Two line long caption}
		\label{fig:replay}
	\end{figure}
\end{frame}
\begin{frame}{Reward changes: experimental protocol}
	\begin{columns}
		\begin{column}{0.5\textwidth}
			\begin{enumerate}
				\item mouse explore maze without cheese and water bucket
				\item cheese is added
				\item mouse run $20$ episodes of food retrieval
				\item water bucket is added and more rewarding
				\item mouse run $20$ episodes of food retrieval
			\end{enumerate}
		\end{column}
		\begin{column}{0.5\textwidth}  %%<--- here
			\begin{center}
				\includegraphics[width=\textwidth]{img/relearn_maze.pdf}
			\end{center}
		\end{column}
	\end{columns}
\end{frame}
\begin{frame}{Reward changes: results}
	\begin{figure}
			\centering
			\subfloat{\includegraphics[width=0.6\textwidth]{img/simple_Relearn_tolman_maze_SR-TD_AC.pdf} \label{fig:relearn_SR_TD}}
			
			\subfloat{\includegraphics[width=0.6\textwidth]{img/simple_Relearn_tolman_maze_SR-distance.pdf} \label{fig:relearn_distance}}
\end{figure}
\end{frame}
\subsection{Goal-directed behaviour modelling}
\begin{frame}{Goal-directed behaviour}
	\newb{Goal-directed: what we want}{
	\begin{itemize}
		\item learn without reward
		\item reach a fixed goal
		\item define on-line algorithm with scalar signal
	\end{itemize}
	}
	\exampleb{Goal-directed algorithms}{
	SR, increase the discounted probability of the wanted goal/feature:
	\begin{itemize}
		\item $  \delta \leftarrow (M^{\pi}(S_{t+1}, :) - M^{\pi}(S_{s_{t}},:))^{T}w$
	\end{itemize}
	SR-distance, decrease the distance of the wanted goal/feature:
		\begin{itemize}
  		\item $\delta \leftarrow (D(S_{t},:) - D(S_{t+1}), :)^{T}w$
		\end{itemize}
		$w$ \alert{fixed feature vector} corresponding to the wanted goal,
		only the actor $A$ is updated. 
		
	}
\end{frame}
\begin{frame}{Goal-directed: experimental protocol}
	\begin{columns}
		\begin{column}{0.5\textwidth}
			\begin{enumerate}
				\item cheese is the new goal
				\item mouse run $20$ episodes of food retrieval
				\item water bucket is the new goal
				\item mouse run $20$ episodes of food retrieval
			\end{enumerate}
		\end{column}
		\begin{column}{0.5\textwidth}  %%<--- here
			\begin{center}
				\includegraphics[width=\textwidth]{img/relearn_maze.pdf}
			\end{center}
		\end{column}
	\end{columns}
\end{frame}
\begin{frame}{Goal-directed: Results}
	\begin{figure}
		\centering
		\includegraphics[width=\linewidth]{img/Goal_directed_two_goal.pdf}
		%\caption{Two line long caption}
		\label{fig:replay}
	\end{figure}
\end{frame}
\subsection{Clustering for sub-goal discovery}
\begin{frame}{Clustering for sub-goal discovery}
\newb{Motivations}{
	\begin{itemize}
		\item $D$ give topological information between states
		\item Create clustering with simple \emph{mean-shift} algorithm 
		\item Abstract sub-goal by creating group of states
		\item \emph{Mean-shift} hyper-parameter can be interpreted as sub-goal granularity: hierarchical sub-goal discovery
	\end{itemize}
}
\end{frame}
\begin{frame}{Clustering with three rooms maze}
	\begin{figure}
		\centering
		\subfloat[Experimental protocol]{\includegraphics[width=0.3\linewidth]{img/three_rooms.pdf} \label{fig:three_protocol}}
		\subfloat[Mean-shift result]{\includegraphics[width=0.7\linewidth]{img/clusterin_3_rooms_0.pdf} \label{fig:three_results}}
	\end{figure}
\end{frame}
\begin{frame}{Clustering with Russek' latent maze}
			\begin{figure}
			\centering
			\subfloat[Experimental protocol]{\includegraphics[width=0.3\textwidth]{img/russek_latent_maze.pdf} \label{fig:russek_protocol}}
			\subfloat[Mean-shift result]{\includegraphics[width=0.7\textwidth]{img/clustering_latent_russek_6.pdf} \label{fig:russek_results}}
		\end{figure}
\end{frame}
\begin{frame}{Hierarchical clustering with Russek' latent maze}
\begin{figure}
	\centering
	\subfloat[\(q = 0.10\)]{\includegraphics[width=0.5\textwidth,height=0.3\textheight]{img/clustering_latent_russek_0_10.pdf}\label{fig:latent_10}}
	\subfloat[\(q = 0.15\)]{\includegraphics[width=0.5\textwidth,height=0.3\textheight]{img/clustering_latent_russek_0_15.pdf}\label{fig:latent_15}}
	
	\subfloat[\(q = 0.20\)]{\includegraphics[width=0.5\textwidth,height=0.3\textheight]{img/clustering_latent_russek_0_20.pdf}\label{fig:latent_20}}
	\subfloat[\(q = 0.25\)]{\includegraphics[width=0.5\textwidth,height=0.3\textheight]{img/clustering_latent_russek_0_25.pdf}\label{fig:latent_25}}
	
	\label{fig:H_clustering}
\end{figure}
\end{frame}
\begin{frame}{Hierarchical clustering with Russek' latent maze}
 \begin{figure}
 		\subfloat[\(q = 0.30\)]{\includegraphics[width=0.5\textwidth,height=0.3\textheight]{img/clustering_latent_russek_0_30.pdf}\label{fig:latent_30}}
 	\subfloat[\(q = 0.35\)]{\includegraphics[width=0.5\textwidth,height=0.3\textheight]{img/clustering_latent_russek_0_35.pdf}\label{fig:latent_35}}
 	
 	\subfloat[\(q = 0.4\)]{\includegraphics[width=0.5\textwidth,height=0.3\textheight]{img/clustering_latent_russek_0_40.pdf}\label{fig:latent_40}}
 	
 \end{figure}
\end{frame}

\section{Discussion}
\begin{frame}{Discussion}
	\newb{New learning methods with vectorial information}{
	\begin{itemize}
		\item Outperform previous methods
		\item Model food retrieval behaviour
		\item Model recent finding for spatial representation with vectorial information observe in bats, rats and human   
	\end{itemize}}
	\pause
	\newb{Goal-directed behaviour modelling}{
		\begin{itemize}
			\item Model learning without reward
			\item Can model theory of goal-directed and habits behaviour as an entangle system
		\end{itemize}}

\end{frame}
\begin{frame}{Discussion}
		\newb{Clustering capacities}{
		\begin{itemize}
			\item Sub-goal discovery
			\item Hierarchical learning
	\end{itemize}}
	\pause
	\newb{Future works}{
		\begin{itemize}
			\item Test SR-distance on complex environment like 3D maze 
			
			\item Integrate SR and SR-distance in spiking neural network model of the hippocampus
	\end{itemize}}
\end{frame}
\begin{frame}{SR state value-function}
	\newb{SR method \footnotemark}{
		\begin{align*}
		V^{\pi}(s_i) = \sum\limits_{s_j \in \mathcal{S}} M^{\pi}(s_i, s_j) \, w(s_j)
		\end{align*}
		Following the transition $s \overset{a}{\rightarrow} s'$, we update $w$ and $A$:
		\begin{align*}
		\delta &= R(s,a) + \gamma_{td}v(s') - v(s) \nonumber \\
		w(i) &\leftarrow w(i) + \alpha_{td} \delta M^{\pi}(s, i) \nonumber \\
		A(a, i) &\leftarrow A(a, i) + \beta_{td} \delta \mathbb{I}(i = s), \quad\forall i \in \mathcal{S}
		\end{align*}	
	}
	\footnotetext[3]{Russek EM, Momennejad I, Botvinick MM, Gershman SJ, Daw ND (2017) Predictive representations can link model-based reinforcement learning to model-free mechanisms. PLOS Computational Biology 13(9): e1005768. https://doi.org/10.1371/journal.pcbi.1005768}
\end{frame}

\end{document}
